import * as React from 'react';
const matchWindowMedia = (query) => {
    if (typeof window === 'object' && window.matchMedia) {
        return window.matchMedia(query).matches;
    }
    return false;
};
export function executeMediaQuery(queries) {
    const matches = {};
    Object.keys(queries).forEach((media) => {
        const query = queries[media];
        matches[media] = typeof query === 'string' ? matchWindowMedia(query) : query;
    });
    return matches;
}
export class Media extends React.Component {
    constructor(props) {
        super(props);
        this.state = {
            matches: {},
            matchers: {},
            keys: [],
        };
        this.updateMatches = () => this.setState(({ keys, matchers, matches }) => ({
            matches: keys.reduce((acc, key) => {
                acc[key] = matchers[key].matches;
                return acc;
            }, {
                ...matches,
            }),
        }));
        if (typeof window !== 'object' || !window.matchMedia) {
            return;
        }
        const { queries } = props;
        const keys = Object.keys(queries);
        this.state.keys = keys;
        Object.keys(queries).forEach((media) => {
            const query = queries[media];
            if (typeof query === 'string') {
                this.state.matches[media] = (this.state.matchers[media] = window.matchMedia(query)).matches;
            }
            else {
                this.state.matches[media] = query;
            }
        });
    }
    componentDidMount() {
        const { matchers } = this.state;
        Object.keys(matchers).forEach((match) => matchers[match].addEventListener('change', this.updateMatches));
    }
    componentWillUnmount() {
        const { matchers } = this.state;
        Object.keys(matchers).forEach((match) => matchers[match].removeEventListener('change', this.updateMatches));
    }
    render() {
        const { children } = this.props;
        const { matches } = this.state;
        return children(matches);
    }
}
