import { MediaMatcherType, MediaRulesOf, ObjectShape } from './types';
/**
 * Creates a group media matcher
 * @param queries - an object with keys - state names, and values - media queries
 * @example
 * createMediaMatcher({
 *   small: '(max-width: 600px)',
 *   big: '(min-width: 600px)',
 * });
 * @see https://github.com/thearnica/react-media-match#api
 */
export declare function createMediaMatcher<T extends ObjectShape>(queries: MediaRulesOf<T>): MediaMatcherType<T, keyof T>;
export declare function createMediaMatcher<T extends ObjectShape, FirstKey extends keyof T = keyof T>(queries: MediaRulesOf<T>, firstKey: FirstKey): MediaMatcherType<T, FirstKey>;
