import { createMediaMatcher } from './createMediaMatcher';
/**
 * Picks value from Slots for matching Match)
 * @type {<K>(matches: BoolOf<T>, slots: ObjectOf<T, K>) => K}
 */
declare const pickMatch: {
    <K>(matches: import("./types").ObjectOf<{
        readonly mobile: unknown;
        readonly tablet: unknown;
        readonly desktop: unknown;
    }, boolean>, slots: import("./types").WithRequiredKeysSet<import("./types").ObjectOf<{
        readonly mobile: unknown;
        readonly tablet: unknown;
        readonly desktop: unknown;
    }, K>, "mobile">): K;
    <K_1>(matches: import("./types").ObjectOf<{
        readonly mobile: unknown;
        readonly tablet: unknown;
        readonly desktop: unknown;
    }, boolean>, slots: Partial<import("./types").ObjectOf<{
        readonly mobile: unknown;
        readonly tablet: unknown;
        readonly desktop: unknown;
    }, K_1>>): K_1 | undefined;
    <K_2, DK>(matches: import("./types").ObjectOf<{
        readonly mobile: unknown;
        readonly tablet: unknown;
        readonly desktop: unknown;
    }, boolean>, slots: Partial<import("./types").ObjectOf<{
        readonly mobile: unknown;
        readonly tablet: unknown;
        readonly desktop: unknown;
    }, K_2>>, defaultValue: DK): K_2 | DK;
};
/**
 * Provides Context for underlying consumers
 * @type {SFC}
 */
declare const ProvideMediaMatchers: import("react").FC<{
    state?: import("./types").ObjectOf<{
        readonly mobile: unknown;
        readonly tablet: unknown;
        readonly desktop: unknown;
    }, boolean> | undefined;
    children: import("react").ReactNode;
}>;
/**
 * Consumes provided information from context and returns via renderProps
 * @type {SFC<{children: RenderMatch<any>}>}
 */
declare const MediaMatches: import("./types").LeafComponent<{
    children: import("./types").RenderMatch<{
        readonly mobile: unknown;
        readonly tablet: unknown;
        readonly desktop: unknown;
    }, any>;
}>;
/**
 * Calculates media match and renders a rule
 * @type {SFC<RenderOf<any>>}
 */
declare const InlineMediaMatcher: import("./types").LeafComponent<Partial<import("./types").ObjectOf<{
    readonly mobile: unknown;
    readonly tablet: unknown;
    readonly desktop: unknown;
}, import("react").ReactNode>>>;
/**
 * Consumes provided information and renders matched rule
 * @type {SFC<RenderOf<any>>}
 */
declare const MediaMatcher: import("./types").LeafComponent<Partial<import("./types").ObjectOf<{
    readonly mobile: unknown;
    readonly tablet: unknown;
    readonly desktop: unknown;
}, import("react").ReactNode>>>;
/**
 * Calculates media match and returns via renderProps
 * @type {RPC<any, any>}
 */
declare const Matches: import("./types").LeafComponent<{
    children: import("./types").RenderMatch<{
        readonly mobile: unknown;
        readonly tablet: unknown;
        readonly desktop: unknown;
    }, any>;
}>;
declare const MediaMock: import("react").FC<Partial<import("./types").ObjectOf<{
    readonly mobile: unknown;
    readonly tablet: unknown;
    readonly desktop: unknown;
}, import("react").ReactNode>> & {
    children: import("react").ReactNode;
}>;
/**
 * Renders only below specific break point
 */
declare const Below: import("react").FC<Partial<import("./types").ObjectOf<{
    readonly mobile: unknown;
    readonly tablet: unknown;
    readonly desktop: unknown;
}, boolean>> & import("./types").Including & {
    children: import("react").ReactNode;
}>;
/**
 * Renders only above specific break point
 */
declare const Above: import("react").FC<Partial<import("./types").ObjectOf<{
    readonly mobile: unknown;
    readonly tablet: unknown;
    readonly desktop: unknown;
}, boolean>> & import("./types").Including & {
    children: import("react").ReactNode;
}>;
/**
 * ServerSide rendering helper
 */
declare const MediaServerRender: import("react").FC<{
    predicted: "mobile" | "tablet" | "desktop";
    hydrated?: boolean | undefined;
    children: import("react").ReactNode;
    onWrongPrediction?(predicted: "mobile" | "tablet" | "desktop", factual: "mobile" | "tablet" | "desktop"): void;
}>;
declare const MediaConsumer: import("react").Consumer<Partial<import("./types").ObjectOf<{
    readonly mobile: unknown;
    readonly tablet: unknown;
    readonly desktop: unknown;
}, boolean>>>;
/**
 * pickMatchHookAPI
 */
declare const useMedia: {
    <K>(slots: import("./types").WithRequiredKeysSet<import("./types").ObjectOf<{
        readonly mobile: unknown;
        readonly tablet: unknown;
        readonly desktop: unknown;
    }, K>, "mobile">): K;
    <K_1>(slots: Partial<import("./types").ObjectOf<{
        readonly mobile: unknown;
        readonly tablet: unknown;
        readonly desktop: unknown;
    }, K_1>>): K_1 | undefined;
    <K_2, DK>(slots: Partial<import("./types").ObjectOf<{
        readonly mobile: unknown;
        readonly tablet: unknown;
        readonly desktop: unknown;
    }, K_2>>, defaultValue: DK): K_2 | DK;
};
export { createMediaMatcher, pickMatch, ProvideMediaMatchers, MediaMatches, InlineMediaMatcher, Above, Below, MediaMatcher, MediaServerRender, Matches, MediaMock, MediaConsumer, useMedia, };
