import * as React from 'react';
import { BoolOf, MediaRulesOf } from './types';
export interface BoolHash {
    [key: string]: boolean;
}
export interface IQuery {
    [key: string]: string | boolean;
}
export interface MediaProps {
    queries: IQuery;
    children: (matches: BoolHash) => React.ReactNode;
}
export interface MediaState {
    matches: BoolHash;
    matchers: {
        [key: string]: MediaQueryList;
    };
    keys: string[];
}
export declare function executeMediaQuery<T>(queries: MediaRulesOf<T>): BoolOf<T>;
export declare class Media extends React.Component<MediaProps, MediaState> {
    state: MediaState;
    constructor(props: MediaProps);
    updateMatches: () => void;
    componentDidMount(): void;
    componentWillUnmount(): void;
    render(): React.ReactNode;
}
